package com.hikvision.ctm05smartpass.api.bizservice.impl;

package ..deTemp.1729471347383;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.hikvision.ctm05smartpass.api.bizservice.IPersonalInfoService;
import com.hikvision.ctm05smartpass.api.response.PersonalBaseInfoVo;
import com.hikvision.ctm05smartpass.api.response.PersonalCardBalanceVo;
import com.hikvision.ctm05smartpass.api.response.PersonalPassAndTransactionRecordVo;
import com.hikvision.ctm05smartpass.authority.error.CommonErrorCode;
import com.hikvision.ctm05smartpass.authority.exception.BusinessRuntimeException;
import com.hikvision.ctm05smartpass.authority.req.zhengyuan.GetTransactionReq;
import com.hikvision.ctm05smartpass.authority.resp.zhengyuan.AccountDetailVo;
import com.hikvision.ctm05smartpass.authority.resp.zhengyuan.TransactionRecordVo;
import com.hikvision.ctm05smartpass.authority.resp.zhengyuan.TransactionVo;
import com.hikvision.ctm05smartpass.authority.resp.zhengyuan.WalletVo;
import com.hikvision.ctm05smartpass.authority.service.ExportCommonManager;
import com.hikvision.ctm05smartpass.authority.service.IZhengyuanService;
import com.hikvision.ctm05smartpass.authority.service.ImageFileStorageManager;
import com.hikvision.ctm05smartpass.common.constant.OneQRUnblockedConstant;
import com.hikvision.ctm05smartpass.common.dto.FaceTipConfigDto;
import com.hikvision.ctm05smartpass.common.enums.CertTypeEnum;
import com.hikvision.ctm05smartpass.common.enums.DirectionTypeEnum;
import com.hikvision.ctm05smartpass.common.enums.PersonSexEnum;
import com.hikvision.ctm05smartpass.common.enums.PersonTypeEnum;
import com.hikvision.ctm05smartpass.common.pdms.AppMenu;
import com.hikvision.ctm05smartpass.common.req.PassUseParam;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.Card;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.Org;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.Person;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.PersonExtendedInfo;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.PersonFace;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.PersonStatusMapping;
import com.hikvision.ctm05smartpass.common.resourcesync.entity.YrfsTypeMapping;
import com.hikvision.ctm05smartpass.common.resp.PageData;
import com.hikvision.ctm05smartpass.common.service.CardService;
import com.hikvision.ctm05smartpass.common.service.IEntService;
import com.hikvision.ctm05smartpass.common.service.ILoginUserInfoService;
import com.hikvision.ctm05smartpass.common.service.OrgService;
import com.hikvision.ctm05smartpass.common.service.PersonExtendedInfoService;
import com.hikvision.ctm05smartpass.common.service.PersonFaceService;
import com.hikvision.ctm05smartpass.common.service.PersonService;
import com.hikvision.ctm05smartpass.common.service.PersonStatusMappingService;
import com.hikvision.ctm05smartpass.common.service.TeacherYrfsService;
import com.hikvision.ctm05smartpass.common.service.YrfsTypeMappingService;
import com.hikvision.ctm05smartpass.common.trace.PersonAccessRecordReq;
import com.hikvision.ctm05smartpass.common.trace.PersonRecordData;
import com.hikvision.ctm05smartpass.common.trace.PersonTraceData;
import com.hikvision.ctm05smartpass.common.utils.PdmsServiceUtils;
import com.hikvision.ctm05smartpass.common.utils.StringUtil;
import com.hikvision.starfish.autoconfigure.redis.HikAutoAddRedisKeyPrefix;
import com.hikvision.starfish.core.json.JsonUtil;
import com.hikvision.starfish.core.response.api.ApiPageListData;
import com.hikvision.starfish.core.response.api.ApiResponse;
import com.hikvision.starfish.isupm.client.UpmClient;
import com.hikvision.starfish.isupm.dto.request.UsersRequestDto;
import com.hikvision.starfish.isupm.dto.response.UserDto;
import com.hikvision.starfish.pdms.dto.request.ModelDataQueryReq;
import com.hikvision.starfish.pdms.dto.request.SortDto;
import com.hikvision.starfish.pdms.service.IPdmsService;
import java.io.IOException;
import java.io.InputStream;
import java.lang.invoke.SerializedLambda;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import log.HikLog;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.util.Base64Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;

@Service
public class PersonalInfoServiceImpl implements IPersonalInfoService {
  private static final Logger log = LoggerFactory.getLogger(com.hikvision.ctm05smartpass.api.bizservice.impl.PersonalInfoServiceImpl.class);
  
  @Autowired
  private ILoginUserInfoService userInfoService;
  
  @Autowired
  private ImageFileStorageManager imageFileStorageManager;
  
  @Autowired
  private PersonService personService;
  
  @Autowired
  private OrgService orgService;
  
  @Autowired
  private CardService cardService;
  
  @Autowired
  private PersonFaceService personFaceService;
  
  @Autowired
  private IZhengyuanService zhengyuanService;
  
  @Autowired
  private IEntService entService;
  
  @Autowired
  private IPdmsService pdmsService;
  
  @Autowired
  private PdmsServiceUtils pdmsServiceUtils;
  
  @Autowired
  private UpmClient upmClient;
  
  @Autowired
  private ThreadPoolTaskExecutor taskExecutor;
  
  @HikAutoAddRedisKeyPrefix
  @Autowired
  public RedisTemplate redisTemplate;
  
  @Autowired
  private ExportCommonManager exportCommonManager;
  
  @Autowired
  private PersonExtendedInfoService personExtendedInfoService;
  
  @Autowired
  private YrfsTypeMappingService yrfsTypeMappingService;
  
  @Autowired
  private PersonStatusMappingService personStatusMappingService;
  
  @Autowired
  private TeacherYrfsService teacherYrfsService;
  
  @Value("${exchange.type:false}")
  private boolean exchangeType;
  
  public PersonalBaseInfoVo getBaseInfoByUserId(String userId) {
    log.info("user【{}】 accessing the homepage to get BaseInfo", Base64Util.encode(userId));
    String redisVOStr = (String)this.redisTemplate.opsForValue().get("qr_person_info_" + userId);
    PersonalBaseInfoVo redisVO = (PersonalBaseInfoVo)JSONObject.parseObject(redisVOStr, PersonalBaseInfoVo.class);
    if (!ObjectUtils.isEmpty(redisVO))
      return redisVO; 
    PersonalBaseInfoVo vo = new PersonalBaseInfoVo();
    Person person = this.personService.getPersonByUserId(userId);
    if (person == null) {
      log.info("user【{}】base info is null, please check data", Base64Util.encode(userId));
      return vo;
    } 
    BeanUtils.copyProperties(person, vo);
    vo.setUserId(userId);
    if (person.getSex() != null)
      vo.setSexName(PersonSexEnum.getDescription(person.getSex())); 
    Org org = (Org)this.orgService.getById(person.getOrgId());
    if (org != null)
      vo.setDeptName(org.getOrgName()); 
    List<Card> cardList = this.cardService.list((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper()).eq(Card::getPersonId, person.getPersonId()))
        .isNotNull(Card::getDisplayCardNo)).eq(Card::getUseStatus, Integer.valueOf(1))).eq(Card::getStatus, Integer.valueOf(0))).orderByDesc(Card::getUpdateTime));
    if (CollectionUtils.isNotEmpty(cardList))
      vo.setCardNo(((Card)cardList.get(0)).getDisplayCardNo()); 
    PersonFace personFace = (PersonFace)this.personFaceService.getById(person.getPersonId());
    if (personFace != null) {
      String picUrl = StringUtils.isNotEmpty(personFace.getDisplayFaceUrl()) ? personFace.getDisplayFaceUrl() : (StringUtils.isNotEmpty(personFace.getFaceUrl()) ? personFace.getFaceUrl() : null);
      if (StringUtils.isNotBlank(picUrl)) {
        this.redisTemplate.opsForValue().setIfAbsent("qr_person_photo_info_" + userId, picUrl, 3600L, TimeUnit.SECONDS);
        vo.setFaceUrl("/ctm05smartpass/h5/v1/personal/getPersonImage");
      } 
    } 
    PersonExtendedInfo personExtendedInfo = (PersonExtendedInfo)this.personExtendedInfoService.getById(person.getPersonId());
    if (ObjectUtils.isNotEmpty(personExtendedInfo)) {
      vo.setNationCode(personExtendedInfo.getNationCode());
      vo.setNationName(personExtendedInfo.getNationName());
      PersonStatusMapping psm = (PersonStatusMapping)this.personStatusMappingService.getOne((Wrapper)((QueryWrapper)(new QueryWrapper())
          .eq("person_type", person.getPersonType())).eq("person_status", personExtendedInfo.getPersonStatus()));
      if (ObjectUtils.isNotEmpty(psm)) {
        vo.setStatus(psm.getMappingStatus());
        vo.setStatusName(psm.getMappingStatusName());
      } 
    } 
    if (vo.getPersonType() != null && PersonTypeEnum.TEACHER.getCode().equals(vo.getPersonType()) && this.exchangeType) {
      List<YrfsTypeMapping> ytmList = this.yrfsTypeMappingService.getYrfsTypeMappingByPersonIds(Arrays.asList(new String[] { person.getPersonId() }));
      if (!CollectionUtils.isEmpty(ytmList)) {
        vo.setPersonType(((YrfsTypeMapping)ytmList.get(0)).getPersonType());
        vo.setPersonTypeName(PersonTypeEnum.getDescription(((YrfsTypeMapping)ytmList.get(0)).getPersonType()));
      } 
    } else {
      vo.setPersonTypeName(PersonTypeEnum.getDescription(vo.getPersonType()));
    } 
    this.redisTemplate.opsForValue().setIfAbsent("qr_person_info_" + userId, 
        JSONObject.toJSONString(vo), 3600L, TimeUnit.SECONDS);
    return vo;
  }
  
  public PersonalCardBalanceVo getCardBalance(String personId) {
    PersonalCardBalanceVo vo = new PersonalCardBalanceVo();
    UserDto userDto = getUserInfo();
    log.info("user【{}】 accessing the homepage to get ZYCard Wallet", Base64Util.encode(userDto.getUserId()));
    Person person = this.personService.getPersonByUserId(userDto.getUserId());
    if (null == person) {
      log.debug("user【{}】 no association person to get ZYCard Wallet", Base64Util.encode(userDto.getUserId()));
      return vo;
    } 
    String redisVOStr = (String)this.redisTemplate.opsForValue().get("qr_account_info_" + person.getPersonId());
    AccountDetailVo accountDetail = (AccountDetailVo)JSONObject.parseObject(redisVOStr, AccountDetailVo.class);
    if (ObjectUtils.isEmpty(accountDetail)) {
      List<Card> cardList = this.cardService.list((Wrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)(new LambdaQueryWrapper()).eq(Card::getPersonId, person.getPersonId()))
          .isNotNull(Card::getAccNum)).isNotNull(Card::getCardAccNum))
          .eq(Card::getUseStatus, Integer.valueOf(1))).eq(Card::getStatus, Integer.valueOf(0))).orderByDesc(Card::getUpdateTime));
      if (CollectionUtils.isNotEmpty(cardList)) {
        accountDetail = AccountDetailVo.builder().accName(person.getName()).idNo(person.getCertificateNo()).accNum(((Card)cardList.get(0)).getAccNum()).cardAccNum(((Card)cardList.get(0)).getCardAccNum()).build();
        if (CertTypeEnum.IDENTITY_CARD.getCode().equals(person.getCertType())) {
          accountDetail.setIdTypeNum("1");
        } else if (CertTypeEnum.PASSPORT.getCode().equals(person.getCertType())) {
          accountDetail.setIdTypeNum("2");
        } else if (CertTypeEnum.WORD_CARD.getCode().equals(person.getCertType())) {
          accountDetail.setIdTypeNum("4");
        } else if (CertTypeEnum.STUDENT_CARD.getCode().equals(person.getCertType())) {
          accountDetail.setIdTypeNum("3");
        } else if (CertTypeEnum.HONG_KONG_CARD.getCode().equals(person.getCertType())) {
          accountDetail.setIdTypeNum("7");
        } else {
          accountDetail.setIdTypeNum("6");
        } 
      } 
    } 
    if (accountDetail != null && StringUtils.isNotEmpty(accountDetail.getAccNum()) && StringUtils.isNotEmpty(accountDetail.getCardAccNum())) {
      vo.setHasCard(Boolean.valueOf(true));
      WalletVo walletVo = this.zhengyuanService.getPersonWallet(accountDetail.getAccNum(), accountDetail.getCardAccNum());
      if (walletVo != null)
        vo.setBalance(walletVo.getBalance()); 
      this.redisTemplate.opsForValue().setIfAbsent("qr_account_info_" + person.getPersonId(), 
          JSONObject.toJSONString(accountDetail), 3600L, TimeUnit.SECONDS);
    } 
    return vo;
  }
  
  private UserDto getUserInfo() {
    String userId = this.userInfoService.getUserName();
    UsersRequestDto dto = new UsersRequestDto();
    List<String> userIds = Arrays.asList(new String[] { userId });
    dto.setUserIds(userIds);
    ApiResponse<ApiPageListData<UserDto>> resp = this.upmClient.getUser(dto);
    if (ObjectUtils.isEmpty(resp) || ObjectUtils.isEmpty(resp.getData()) || 
      CollectionUtils.isEmpty(((ApiPageListData)resp.getData()).getList())) {
      log.error("Current user 【{}】 is no access region.", Base64Util.encode(userId));
      throw new BusinessRuntimeException(CommonErrorCode.ERR_H5_LOGIN_ERROR.getCode(), CommonErrorCode.ERR_H5_LOGIN_ERROR
          .getMessage());
    } 
    UserDto userDto = ((ApiPageListData)resp.getData()).getList().get(0);
    return userDto;
  }
  
  public List<PersonalPassAndTransactionRecordVo> getPassAndTransactionRecords(String personId, Integer limit) {
    List<PersonalPassAndTransactionRecordVo> vos = new ArrayList<>();
    Person person = (Person)this.personService.getById(personId);
    if (person == null)
      return vos; 
    PersonAccessRecordReq personAccessRecordReq = new PersonAccessRecordReq();
    personAccessRecordReq.setCertificateNo(person.getCertificateNo());
    personAccessRecordReq.setPersonName(person.getName());
    personAccessRecordReq.setPageSize(limit);
    personAccessRecordReq.setSourceTypeCode("2,3,5");
    PersonRecordData personAccessRecord = this.entService.getPersonAccessRecord(personAccessRecordReq);
    log.debug(HikLog.toLog("query personal access records:{}"), JsonUtil.toJson(personAccessRecord));
    if (personAccessRecord != null && "0".equals(personAccessRecord.getCode())) {
      PersonRecordData.DataDTO data = personAccessRecord.getData();
      if (data != null && CollectionUtils.isNotEmpty(data.getResult()))
        for (PersonRecordData.DataDTO.ResultsDTO accessRecord : data.getResult()) {
          PersonalPassAndTransactionRecordVo vo = new PersonalPassAndTransactionRecordVo();
          vo.setRecordType(String.valueOf(1));
          String accessTypeName = DirectionTypeEnum.OTHERS.name();
          if (StringUtils.isNotBlank(accessRecord.getAccessType()))
            try {
              accessTypeName = DirectionTypeEnum.getDescription(Integer.valueOf(accessRecord.getAccessType()));
            } catch (Exception e) {
              accessTypeName = DirectionTypeEnum.OTHERS.name();
            }  
          vo.setRecordName(accessRecord.getCameraName() + " " + accessTypeName);
          DateTime dateTime = DateUtil.parse(accessRecord.getRecordTime(), "yyyy-MM-dd HH:mm:ss");
          vo.setRecordTimeSort((Date)dateTime);
          vo.setRecordTimeShow(DateUtil.format((Date)dateTime, "yyyy-MM-dd HH:mm"));
          vos.add(vo);
        }  
    } 
    AccountDetailVo accountDetail = this.zhengyuanService.getAccountDetailByPersonId(personId);
    if (accountDetail != null && StringUtils.isNotEmpty(accountDetail.getAccNum())) {
      GetTransactionReq getTransactionReq = new GetTransactionReq();
      getTransactionReq.setAccNum(accountDetail.getAccNum());
      getTransactionReq.setLimit(limit.toString());
      TransactionVo transactionVo = this.zhengyuanService.getTransactionRecords(getTransactionReq);
      log.debug(HikLog.toLog("query zhengyuan transaction records:{}"), JsonUtil.toJson(transactionVo));
      if (transactionVo != null && CollectionUtils.isNotEmpty(transactionVo.getList()))
        for (TransactionRecordVo transactionRecordVo : transactionVo.getList()) {
          PersonalPassAndTransactionRecordVo vo = new PersonalPassAndTransactionRecordVo();
          vo.setRecordType(String.valueOf(2));
          String dealRecordName = transactionRecordVo.getMonDeal() + "元";
          vo.setRecordName(transactionRecordVo.getDeviceName() + " " + dealRecordName);
          DateTime dateTime = DateUtil.parse(transactionRecordVo.getDealTime(), "yyyy-MM-dd HH:mm:ss");
          vo.setRecordTimeSort((Date)dateTime);
          vo.setRecordTimeShow(DateUtil.format((Date)dateTime, "yyyy-MM-dd HH:mm"));
          vos.add(vo);
        }  
    } 
    if (CollectionUtils.isNotEmpty(vos))
      vos.sort(Comparator.<PersonalPassAndTransactionRecordVo, Comparable>comparing(PersonalPassAndTransactionRecordVo::getRecordTimeSort).reversed()); 
    if (vos.size() > limit.intValue())
      return vos.subList(0, limit.intValue()); 
    return vos;
  }
  
  public List<AppMenu> getAppMenuList(HttpServletRequest request) {
    List<AppMenu> redisList = OneQRUnblockedConstant.MENU_LIST;
    if (!CollectionUtils.isEmpty(redisList))
      return redisList; 
    ModelDataQueryReq modelDataQueryReq = new ModelDataQueryReq();
    modelDataQueryReq.setFields("*");
    modelDataQueryReq.setFiledOptions(null);
    modelDataQueryReq.setPageNo(PdmsServiceUtils.DEFAULT_PAGE_NO.intValue());
    modelDataQueryReq.setPageSize(PdmsServiceUtils.RECORD_MAX_SIZE.intValue());
    SortDto sortDto = new SortDto();
    sortDto.setSortField("sort");
    sortDto.setSortType("asc");
    SortDto sortDtoTime = new SortDto();
    sortDtoTime.setSortField("update_time");
    sortDtoTime.setSortType("desc");
    modelDataQueryReq.setSorts(Arrays.asList(new SortDto[] { sortDto, sortDtoTime }));
    List<AppMenu> returnList = new ArrayList<>();
    try {
      ApiResponse<ApiPageListData<Map<String, Object>>> apiResponse = this.pdmsService.queryRecords("tb_app_menu", modelDataQueryReq, this.pdmsServiceUtils.getHeaders());
      if (apiResponse != null && apiResponse.getData() != null) {
        List<Map<String, Object>> recordList = ((ApiPageListData)apiResponse.getData()).getList();
        CountDownLatch countDownLatch = new CountDownLatch(recordList.size());
        recordList.stream().forEach(m -> this.taskExecutor.execute(()));
        try {
          countDownLatch.await();
        } catch (InterruptedException e) {
          log.error("query app menu fail :{}", e);
        } 
        List<AppMenu> sortedMenu = (List<AppMenu>)returnList.stream().sorted(Comparator.comparing(AppMenu::getSort)).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(sortedMenu)) {
          log.info("OneQRUnblockedConstant.MENU_LIST sortedMenu value:{}", JSONObject.toJSON(sortedMenu));
          if (!CollectionUtils.isEmpty(OneQRUnblockedConstant.MENU_LIST))
            log.info("OneQRUnblockedConstant.MENU_LIST value:{}", JSONObject.toJSON(OneQRUnblockedConstant.MENU_LIST)); 
          OneQRUnblockedConstant.MENU_LIST.clear();
          log.info("OneQRUnblockedConstant.MENU_LIST clear value:{}", JSONObject.toJSON(OneQRUnblockedConstant.MENU_LIST));
          OneQRUnblockedConstant.MENU_LIST.addAll(sortedMenu);
          log.info("OneQRUnblockedConstant.MENU_LIST new value:{}", JSONObject.toJSON(OneQRUnblockedConstant.MENU_LIST));
          return sortedMenu;
        } 
      } 
    } catch (Exception e) {
      log.error("query app menu fail :{}", e);
      return new ArrayList<>();
    } 
    return returnList;
  }
  
  public void clearAppH5MenuCache() {
    OneQRUnblockedConstant.MENU_LIST.clear();
  }
  
  public String getExceptionInfoByUserId(String userId) {
    return null;
  }
  
  public PageData<PersonalPassAndTransactionRecordVo> getPassAndTransactionPage(PassUseParam passUseParam) {
    PageData<PersonalPassAndTransactionRecordVo> returnPage = new PageData();
    UserDto userDto = getUserInfo();
    log.info("user【{}】 accessing the homepage to get pass or consumption records", Base64Util.encode(userDto.getUserId()));
    Person person = this.personService.getPersonByUserId(userDto.getUserId());
    if (null == person) {
      log.debug("user【{}】 no association person to pass or consumption records", Base64Util.encode(userDto.getUserId()));
      return returnPage;
    } 
    passUseParam.setPersonId(person.getPersonId());
    PersonTraceData personTraceData = this.entService.getPersonTrackInfobyPage(passUseParam);
    if (ObjectUtils.isEmpty(personTraceData) || ObjectUtils.isEmpty(personTraceData.getData())) {
      log.debug("no current user's consumption records were found:{}" + JSONObject.toJSONString(passUseParam));
      return returnPage;
    } 
    PersonTraceData.DataDTO data = personTraceData.getData();
    List<PersonTraceData.DataDTO.ResultsDTO> results = data.getResult();
    if (CollectionUtils.isNotEmpty(results)) {
      List<PersonalPassAndTransactionRecordVo> returnList = new ArrayList<>();
      results.stream().forEach(rdto -> {
            PersonalPassAndTransactionRecordVo vo = new PersonalPassAndTransactionRecordVo();
            String recordName = "4".endsWith(rdto.getRecordType()) ? (rdto.getCameraName() + " " + rdto.getUseMoney() + "元") : (rdto.getCameraName() + " " + rdto.getAccessTypeName());
            vo.setRecordName(recordName);
            vo.setRecordType(rdto.getRecordType());
            DateTime dateTime = DateUtil.parse(rdto.getTraceTime(), "yyyy-MM-dd HH:mm:ss");
            vo.setRecordTimeSort((Date)dateTime);
            vo.setRecordTimeShow(DateUtil.format((Date)dateTime, "MM/dd HH:mm"));
            returnList.add(vo);
          });
      returnPage.setList(returnList);
    } 
    returnPage.setPageNo(Integer.valueOf(passUseParam.getPageNo()));
    returnPage.setPageSize(Integer.valueOf(passUseParam.getPageSize()));
    returnPage.setTotal(ObjectUtils.isEmpty(data.getTotal()) ? Integer.valueOf(0) : data.getTotal());
    int totalPage = (data.getTotal().intValue() % passUseParam.getPageSize() == 0) ? (data.getTotal().intValue() / passUseParam.getPageSize()) : (data.getTotal().intValue() / passUseParam.getPageSize() + 1);
    returnPage.setTotalPage(Integer.valueOf(totalPage));
    return returnPage;
  }
  
  public FaceTipConfigDto getFaceTipConfig(HttpServletRequest request) {
    FaceTipConfigDto result = (FaceTipConfigDto)this.redisTemplate.opsForValue().get("face_tip_config");
    if (result != null)
      return result; 
    FaceTipConfigDto dbResult = new FaceTipConfigDto();
    ModelDataQueryReq modelDataQueryReq = new ModelDataQueryReq();
    modelDataQueryReq.setFields("*");
    modelDataQueryReq.setFiledOptions(null);
    modelDataQueryReq.setPageNo(PdmsServiceUtils.DEFAULT_PAGE_NO.intValue());
    modelDataQueryReq.setPageSize(PdmsServiceUtils.RECORD_MAX_SIZE.intValue());
    SortDto sortDtoTime = new SortDto();
    sortDtoTime.setSortField("update_time");
    sortDtoTime.setSortType("desc");
    modelDataQueryReq.setSorts(Arrays.asList(new SortDto[] { sortDtoTime }));
    try {
      ApiResponse<ApiPageListData<Map<String, Object>>> apiResponse = this.pdmsService.queryRecords("tb_face_tip_config", modelDataQueryReq, this.pdmsServiceUtils.getHeaders());
      if (apiResponse != null && apiResponse.getData() != null) {
        List<Map<String, Object>> recordList = ((ApiPageListData)apiResponse.getData()).getList();
        if (CollectionUtils.isNotEmpty(recordList)) {
          Map<String, Object> firstOne = recordList.get(0);
          dbResult.setModelDataId(StringUtil.ofStr(firstOne.get("model_data_id")));
          dbResult.setTipContent(StringUtil.ofStr(firstOne.get("tip_content")));
          dbResult.setUpdateTime(StringUtil.ofStr(firstOne.get("update_time")));
          Object examplePicObj = firstOne.get("example_pic");
          if (examplePicObj != null && StringUtils.isNotEmpty(examplePicObj.toString())) {
            String[] picUrls = examplePicObj.toString().split("@");
            InputStream is = null;
            try {
              String imageFullUrl = this.imageFileStorageManager.getImageFullUrl(picUrls[1], 600, request, picUrls[0]);
              String imageFullUrlEncode = URLEncoder.encode(imageFullUrl, "UTF-8").replace("+", "%2B");
              imageFullUrlEncode = URLDecoder.decode(imageFullUrlEncode, "UTF-8");
              dbResult.setExamplePic(imageFullUrl);
              is = this.exportCommonManager.downloadObject(imageFullUrlEncode);
              if (is == null)
                is = this.exportCommonManager.downloadObject(imageFullUrlEncode); 
              byte[] imageData = IOUtils.toByteArray(is);
              dbResult.setExamplePic(imageFullUrl);
              dbResult.setImageData(imageData);
            } catch (Exception e) {
              log.error("query face example pic fail", e);
            } finally {
              try {
                if (is != null)
                  is.close(); 
              } catch (IOException ex) {
                ex.printStackTrace();
              } 
            } 
          } 
        } 
        if (StringUtils.isNotBlank(dbResult.getExamplePic()) && dbResult
          .getExamplePic().contains("http") && dbResult
          .getImageData() == null) {
          this.redisTemplate.delete("face_tip_config");
        } else {
          this.redisTemplate.opsForValue().set("face_tip_config", dbResult, 60L, TimeUnit.MINUTES);
        } 
        return dbResult;
      } 
    } catch (Exception f) {
      log.error("query pdms tb_face_tip_config fail", f);
    } 
    return new FaceTipConfigDto();
  }
}
